#include <Adafruit_APDS9960.h>
#include <LiquidCrystal_I2C.h>

Adafruit_APDS9960 apds;
LiquidCrystal_I2C lcd(0x27, 16, 2);

void setup() {
  apds.begin();
  apds.enableColor(true);
  lcd.init();
  lcd.backlight();
}

void loop() {
  uint16_t red, green, blue, light;

  while (!apds.colorDataReady()) {
    delay(5);
  }

  apds.getColorData(&red, &green, &blue, &light);
  String color = mainColor(red, green, blue);

  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("LUMINOSITA': " + String(light));
  lcd.setCursor(0, 1);
  lcd.print("COLORE: " + color);
  delay(500);
}

String mainColor(uint16_t red, uint16_t green, uint16_t blue) {
  String color = "bianco";
  if (red > (green + blue) * 2) {
    color = "rosso";
  } else if (green > (red + blue) * 0.8) {
    color = "verde";
  } else if (blue > (red + green) * 2.5) {
    color = "blu";
  } else if ((red + green) > blue * 1.3) {
    color = "giallo";
  } else if ((red + blue) > green * 5) {
    color = "magenta";
  } else if ((green + blue) > red * 5) {
    color = "ciano";
  }
  return color;
}